; File:     Calcula19.asm
; by:       RuiLoureiro
;
                        include     Calcula19.glb

      ;include   \masm32\macros\macros.asm         ; masm32 macro file                        
      ;include    \masm32\include\masm32.inc     ; masm32 library include
      ;includelib \masm32\lib\masm32.lib         ; masm32 static library
      ;include    \masm32\include\msvcrt.inc
      ;includelib \masm32\lib\msvcrt.lib

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;       unsigned integers: from -4 294 967 295 = - FFFFFFFFh to
;                                4 294 967 295 = + FFFFFFFFh
;
;       1  - Take the expression from expression, remove all spaces
;             and put it into buffer. Remove return and line feed also.
;             Count the number of characters
;
;             Whenever one procedure exits with carry set
;             we set ErrorZ to 0 or 1
;             If error ErrorZ=0; If overflow ErrorZ=1
;
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$SIGN1$         equ 0
$OPR1$          equ 4
$SIGN2$         equ 8
$OPR2$          equ 12

LENBUFFER       equ 200
LENBUFFER2      equ LENBUFFER + 2
LENBUFFER3      equ LENBUFFER + 20
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.data
_StrTooLong     db "Operand too long", 0
_StrEspress     db "This is your expression: ", 0
_StrResult      db "This is your Result:  ", 0
_StrOverflow    db "Overflow", 0
_StrDivision    db "Division by 0", 0
_StrLine        db "---------------------------------------------", 0
;-----------------------------    
    intro1      db "It does Sub(-), Add(+), Mul(*), Div(/), Remainder(\) and Power(^)",13, 10, 0
    intro2      db "It uses integers from -4 294 967 295 to 4 294 967 295 ",13,10,13,10, 0
    
    
    request     db "Type an expression and press enter [ ex: -2 + 3*(7 - 2*8) + 3^3 ]",13,10, 0   ; screen output
    
    expression  db LENBUFFER2 dup(0)            
                dd 0

                dd LENBUFFER
                dd 0
    buffer      db LENBUFFER dup (0)
                dd 0

                dd LENBUFFER
                dd 0
    NewBuffer   db LENBUFFER dup (0)
                dd 0    

    Signal      dd 0                ; +=0  -=1
    Operation   dd 0                ;1=-   2=+   3=*   4=/  5=\

    _Sign       dd 0                ; +=0  -=1
                dd LENOPERAND
                dd 0
    _Operand    db LENOPERAND dup(0)
                dd 0

                dd LENOPERAND
                dd 0
    _Exponent   db LENOPERAND dup(0)
                dd 0
                
    SignZ       dd 0
    OperandZ    dd 0
    ErrorZ      dd 0        ; 0= error   1=overflow

    ExponentZ   dd 0    
    Exponent    dd 0

    _IsAt       dd 0
    _IsEx       dd 0    
;---

                dd LENOPERAND
                dd 0
    ResultZ     db LENOPERAND dup(0)
                dd 0

                dd LENBUFFER3
                dd 0
    ExpBuffer   db LENBUFFER3 dup (0)
                db 0

                dd 15
                dd 0
    VarBuffer   db 16 dup (0)                
;...........................
                dd 5
_ERROR          db "ERROR"

                dd 15
_ERROR2         db "ResolveIt ERROR"

                dd 8
_OVERFLOW       db "OVERFLOW"
 
_RTLF           db 13, 10, 0    

;                dd 30
;                dd 0
;_TestBuf        db 31 dup (0)
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    _OffsetExp1 dd 0
    _OffsetExp2 dd 0
    _OffsetExp3 dd 0

    _OffsetBas1 dd 0
    _OffsetBas2 dd 0

    _OffsetFst  dd 0
    _OffsetLst  dd 0
     OffsetFst  dd 0
     OffsetLst  dd 0

                dd LENBUFFER
                dd 0
    AuxBuffer   db LENBUFFER dup (0)
                dd 0

                dd LENBUFFER
                dd 0
    WrkBuffer   db LENBUFFER dup (0)
                dd 0
                
                dd LENBUFFER
                dd 0
    BaseBuffer  db LENBUFFER dup (0)
                dd 0                
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                dd 200
                dd 0
    _TblOperand dd 201 dup (0)
                dd 201 dup (0)
                dd 201 dup (0)
                dd 201 dup (0)

                dd 200
                dd 0
  _TblOperation dd 200 dup (0)

                dd 200
                dd 0
  _TblOperandAt dd 200 dup (0)      ; save @
                dd 200 dup (0)

                dd 200
                dd 0
  _TblPower     dd 200 dup (0)      ; save #
                dd 200 dup (0)
                
        _NoAnt  dd 0
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.code
start: 

                invoke      StandardOut, ADDR intro1
                invoke      StandardOut, ADDR intro2                

       main:    invoke      StandardOut, ADDR request         ; display request on screen
                invoke      StandardIn,  ADDR expression, LENGTHOF expression

                call        RemoveSpace
                jz          short start

                invoke      PrintString, addr _StrEspress
                invoke      PrintStringLF, addr buffer
                
                ; 
                ; Get a copy of buffer to NewBuffer
                ; 
                invoke      CpyRclRcl, addr buffer, addr NewBuffer
                
                ; 
                ; Remove blocks of brackets
                ; 
                invoke      RemAspas, addr NewBuffer
                jc          _error
                invoke      VrfSigns, addr NewBuffer
                jc          _error

                invoke      PrintString, addr _StrEspress
                invoke      PrintStringLF, addr NewBuffer

                call        IniExpress

                invoke      LookExpress, addr NewBuffer
                jc          _error

                invoke      ToRclCnv, SignZ, OperandZ, addr ResultZ
                                 
   _result:     call        GetExpress
                
                invoke      PrintString, addr _StrResult 
                invoke      PrintStringLF, addr ResultZ
                
                invoke      PrintStringLF, addr ExpBuffer
                invoke      PrintStringLF, addr _StrLine
                jmp         main
;***---***
    _error:     cmp         ErrorZ, 0
                jne         short _error1

                call        SetError
                jmp         _result
                
    _error1:    cmp         ErrorZ, 1
                jne         short _error2

                call        SetOverflow
                jmp         _result
                
    _error2:    call        SetError2
                jmp         _result
; 
GetExpress      proc

                mov     esi, offset buffer
                mov     edi, offset ExpBuffer
                call    RclRclCpy
                ;
                mov     ecx, dword ptr [edi - 4]
                mov     byte ptr [edi + ecx], '='
                add     ecx, 1
                mov     dword ptr [edi - 4], ecx

                invoke  RclRclAdd, addr ResultZ, addr ExpBuffer
 
                ret
GetExpress      endp
; 
IniExpress      proc

                mov     edx, offset ExpBuffer
                mov     byte ptr [edx], 0
                mov     dword ptr [edx - 4], 0
                
                mov     edx, offset ResultZ
                mov     byte ptr [edx], 0
                mov     dword ptr [edx - 4], 0
                ret
IniExpress      endp 
;--------------------------------------------------------
SetError        proc
                push    esi
                push    edi

                mov     esi, offset _ERROR
                mov     edi, offset ResultZ
                ;
                call    RclRclCpy
                pop     edi
                pop     esi
                ret
SetError        endp
;--------------------------------------------------------
SetError2       proc
                push    esi
                push    edi

                mov     esi, offset _ERROR2
                mov     edi, offset ResultZ
                ;
                call    RclRclCpy
                pop     edi
                pop     esi
                ret
SetError2       endp
;--------------------------------------------------------
SetOverflow     proc
                push    esi
                push    edi
                
                mov     esi, offset _OVERFLOW
                mov     edi, offset ResultZ
                ;
                call    RclRclCpy
                pop     edi
                pop     esi
                ret
SetOverflow     endp
; 
RemoveSpace     proc

                mov     esi, offset expression
                mov     edi, offset buffer
                mov     dword ptr [edi - 4], 0
                mov     byte ptr [edi], 0
                
                xor     ecx, ecx
                jz      short next

@@:             cmp     al, 13
                je      short _exit                 ; return ?
                cmp     al, 10
                je      short _exit                 ; line feed ?

                cmp     al, 20h
                je      short next
                                
                mov     byte ptr [edi + ecx], al
                add     ecx, 1
                ;
next:           movzx   eax, byte ptr [esi]
                add     esi, 1
                
                cmp     al, 0
                jne     short @B
                
_exit:          mov     dword ptr [edi - 4], ecx
                mov     byte ptr [edi + ecx], 0

                or      ecx, ecx
                ret
RemoveSpace     endp
; 
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
RemSpaces       proc    pRcl:DWORD
                push    esi
                push    edi

                mov     esi, [esp + 12]                 ;pRcl
                mov     ecx, dword ptr [esi - 4]
                ;
                mov     edi, offset AuxBuffer
                mov     dword ptr [edi - 4], 0
                xor     ebx, ebx
                xor     edx, edx
                ;
   _loop:       movzx   eax, byte ptr [esi + edx]
                add     edx, 1

                cmp     al, 20h
                je      short @F
                                
                mov     byte ptr [edi + ebx], al
                add     ebx, 1
                ;                
       @@:      sub     ecx, 1
                jnz     short _loop
                
                mov     dword ptr [esi - 4], ebx
                mov     byte ptr [esi + ebx], 0
                
                cmp     ebx, 0
                je      short _exit
                ;
       @@:      sub     ebx, 1
                movzx   eax, byte ptr [edi + ebx]
                mov     byte ptr [esi + ebx], al
                jnz     short @B 
                                
    _exit:      pop     edi
                pop     esi
                ret     4
RemSpaces       endp
;
; Remove ((( ... ))) and ( expression )
;
; Output:
;           clc:    Ok
;
;           stc:    error
;
RemAspas        proc    pRcl:DWORD
                push    esi

                mov     esi, [esp + 8]                 ;pRcl
                
    _start:     mov     ecx, dword ptr [esi - 4]
                ;
                mov     edx, ecx
                sub     edx, 1
                ;
     _loop:     cmp     ecx, 0
                je      _exit
                ;
                sub     ecx, 1
                cmp     byte ptr [esi + ecx], ')'
                jne     short _loop

    _found1:    cmp     ecx, 0
                je      short error

                mov     ebx, ecx

    _next:      sub     ebx, 1
                movzx   eax, byte ptr [esi + ebx]                
                cmp     al, '('
                je      short _found2
                cmp     al, ')'
                jne     short @F
                ;
                mov     ecx, ebx
                je      short _found1
                ;
       @@:      cmp     ebx, 0
                jne     short _next
                je      short error               
;---***---                
    _found2:    cmp     ebx, 0
                je      short _loop
                ;
                sub     ebx, 1

                add     ecx, 1                                
                cmp     ecx, edx
                ja      short _no
                                
                cmp     byte ptr [esi + ecx], ')'
                jne     short _no
                cmp     byte ptr [esi + ebx], '('
                jne     short _no

                mov     byte ptr [esi + ebx], 20h
                mov     byte ptr [esi + ecx], 20h
                invoke  RemSpaces, esi
                jmp     _start
                                
    _no:        sub     ecx, 1
                jmp     _loop
                   
    _exit:      clc
                pop     esi
                ret     4

    error:      mov     ErrorZ, 0
                stc
                pop     esi
                ret     4    
RemAspas        endp
;
; It cannot have 2 signs "+" or "-" before (
; or 3 signs "+" or "-"
;
; Output:
;           clc:    Ok
;
;           stc:    error
;
VrfSigns        proc    pRcl:DWORD
                push    esi

                mov     esi, [esp + 8]                 ;pRcl
                mov     ecx, dword ptr [esi - 4]
                cmp     ecx, 0
                je      _exit
                ;
                mov     edx, ecx
                ;
     _loop:     cmp     ecx, 0
                je      short _next
                ;
                sub     ecx, 1
                cmp     byte ptr [esi + ecx], '('
                jne     short _loop
                ;
                mov     ebx, ecx
                cmp     ebx, 0
                je      short _next
                
                sub     ebx, 1
                cmp     byte ptr [esi + ebx], '+'
                je      short _plus
                cmp     byte ptr [esi + ebx], '-'
                jne     short _loop
                
                cmp     ebx, 0
                je      short _loop

                sub     ebx, 1
                cmp     byte ptr [esi + ebx], '+'
                je      short error
                cmp     byte ptr [esi + ebx], '-'
                je      short error                
                jne     short _loop
                    
    _plus:      cmp     ebx, 0
                je      short _loop

                sub     ebx, 1
                cmp     byte ptr [esi + ebx], '+'
                je      short error
                cmp     byte ptr [esi + ebx], '-'
                je      short error                
                jne     short _loop
;---***---
    _next:      cmp     edx, 0
                je      short _exit
                ;
                sub     edx, 1
                cmp     byte ptr [esi + edx], '+'
                je      short _sign1
                cmp     byte ptr [esi + edx], '-'
                jne     short _next                

    _sign1:     cmp     edx, 0
                je      short _exit

                sub     edx, 1
                cmp     byte ptr [esi + edx], '+'
                je      short _sign2
                cmp     byte ptr [esi + edx], '-'
                jne     short _next

    _sign2:     cmp     edx, 0
                je      short _exit

                sub     edx, 1
                cmp     byte ptr [esi + edx], '+'
                je      short error
                cmp     byte ptr [esi + edx], '-'
                je      short error                
                jne     short _next
                   
    _exit:      clc
                pop     esi
                ret     4

    error:      mov     ErrorZ, 0
                stc
                pop     esi
                ret     4    
VrfSigns        endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef
;
; The expression has not brackets 
; Expressions can be:  
;                       X^N  or  +X^N  or -X^N 
;                     ++X^N  or +-X^N  or -+X^N  or --X^N 
;
; NOT this +(X^N) or -(X^N) because the expression has not brackets
;
;
PowerSignal     proc

                mov     ebx, _OffsetExp1                
                cmp     ebx, 0
                je      short _exit
                
                sub     ebx, 1
                mov     edx, ebx
                movzx   eax, byte ptr [esi + ebx]
                
                cmp     al, '-'
                je      short minus1
                cmp     al, '+'
                je      short plus1
    _exit:      ret
    
    plus1:      cmp     edx, 0
                je      short _exit

                sub     edx, 1
                movzx   eax, byte ptr [esi + edx]

                cmp     al, '+'
                je      short plus2
                
                cmp     al, '-'
                jne     short _exit
                
                mov     byte ptr [esi + edx], '+'
                mov     SignZ, 1
                mov     _OffsetExp1, ebx
                ret
;---***---
   minus1:      cmp     edx, 0
                je      short minus

                sub     edx, 1
                movzx   eax, byte ptr [esi + edx]
                
                cmp     al, '-'
                je      short minus2
                cmp     al, '+'
                je      short minusplus
                
   minus:       mov     byte ptr [esi + ebx], '+'
                mov     SignZ, 1
                ret

   minus2:      mov     byte ptr [esi + edx], '+'
                mov     SignZ, 0
                mov     _OffsetExp1, ebx
                ret
                ;
   minusplus:   mov     SignZ, 1
                ;
   plus2:       mov     _OffsetExp1, ebx
                ret
PowerSignal     endp
;
; LookPower is called before SolveExpress
; The expression pointed by pRcl has not brackets 
; The sign of each power is the sign behind the base
; The base is not an expression. It is a constant
; When the base is an expression, it is solved by IsBaseExpo
;
; The power expression goes from _OffsetExp1 to _OffsetExp2
; (from [esi+_OffsetExp1] to [esi+_OffsetExp2])
;
LookPower       proc    pRcl:DWORD
                push    esi
                
                mov     edx, offset _TblPower
                mov     dword ptr [edx - 4], 0

                mov     esi, pRcl
                mov     ecx, dword ptr [esi - 4]

                cmp     ecx, 0
                jne     short _start
                ;
    error:      stc
                pop     esi
                ret
                ;
    error1:     mov     ErrorZ, 0
                stc
                pop     esi                
                ret
                ;
    overflow:   mov     ErrorZ, 1    
                stc
                pop     esi                
                ret

    _start:     sub     ecx, 1
                cmp     byte ptr [esi + ecx],'^'
                je      short _found1
                ;
    _loop:      cmp     ecx, 0
                jne     short _start
                ;
                ; not found / done
                ; 
                clc
                pop     esi                
                ret
                            
    _found1:    cmp     ecx, 0
                je      short error1
                
                call    GetExponent
                jc      short error                
                
                call    GetBase
                jc      short error

                mov     eax, OperandZ 
                cmp     eax, 0
                je      _null
                ;               
                mov     ecx, Exponent
                
                cmp     ecx, 0
                je      short _one
                
                cmp     eax, 1
                je      short next
                ;
                cmp     ecx, 1
                je      short next
                ;
                sub     ecx, 1
                mov     ebx, eax
                ;
      @@:       mul     ebx
                jc      overflow
                ;
                sub     ecx, 1
                jnz     short @B

                mov     OperandZ, eax       
                jz      short next
;---***---
    _one:       mov     OperandZ, 1
                ;
    next:       call    PowerSignal

                ; 
                ;   Save Power
                ; 
    _save:      call    SaveEx
    
                ; 
                ; Remove Power expression
                ; 
                invoke  RemExpo, esi
                
                ; 
                ;       Restart
                ; 
                mov     ecx, _OffsetExp1
                jmp     _loop
                
                ; 
                ; SignZ=0 OperandZ = 0
                ; 
    _null:      call    PowerSignal
                mov     SignZ, 0
                jmp     short _save                
LookPower       endp
;
; Output:
;           clc:    Ok
;
;           stc:    error / overflow
;
GetBase         proc

                mov     edi, offset _Operand
                xor     ebx, ebx
                
                xor     edx, edx                    ; number of digits
                ;
    next1:      sub     ecx, 1
                mov     al, byte ptr [esi + ecx]
                ;
                cmp     al, '0'
                jb      short _found0
                cmp     al, '9'
                ja      short _found0
                ;
                mov     _OffsetExp1, ecx
                
                add     edx, 1
                push    eax
                ;
                cmp     ecx, 0
                je      short _copy
                ;
                cmp     edx, LENOPERAND
                jbe     short next1
                ja      error2

    _found0:    add     ecx, 1
                cmp     edx, 0
                je      error1
                ;
    _copy:      pop     eax
                mov     byte ptr [edi + ebx], al
                add     ebx, 1
                ;
                sub     edx, 1
                jnz     short _copy

                mov     dword ptr [edi- 4], ebx
                ;
                ; Convert
                ; -------
                invoke  CnvToDW, addr _Operand
                jc      short overflow
                ; 
                mov     OperandZ, eax
                mov     SignZ, 0
;---***---
                ;
    _exit:      clc
                ret                

    error1:     mov     ErrorZ, 0
                stc
                ret

    error2:     pop     eax
                sub     edx, 1
                jnz     short error2
                jz      short error1

    overflow:   mov     ErrorZ, 1
                stc
                ret                
GetBase         endp
;
; Output:
;           clc:    Ok
;
;           stc:    error / overflow
;
GetExponent     proc

                mov     edi, offset _Exponent
                mov     dword ptr [edi - 4], 0
                xor     edx, edx
                
                mov     ebx, ecx                
                add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]
                jae     error
                
    next:       movzx   eax, byte ptr [esi + ebx]
                cmp     al, '0'
                jb      short _exit
                cmp     al, '9'
                ja      short _exit
                ;
                mov     _OffsetExp2, ebx

                mov     byte ptr [edi + edx], al                       
                add     edx, 1

                cmp     edx, LENOPERAND
                ja      error

                add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]                
                jne     short next

    _exit:      mov     dword ptr [edi - 4], edx
                cmp     edx, 0
                je      short error
                ;
                ; Convert
                ; -------
                invoke  CnvToDW, addr _Exponent
                jc      short overflow 

                mov     Exponent, eax
                cmp     eax, 31
                ja      short overflow
                ;                
                clc
                ret
                
    error:      mov     ErrorZ, 0
                stc                
                ret
                
    overflow:   mov     ErrorZ, 1
                stc
                ret
GetExponent     endp
;
AdjustSign      proc
                mov     edx, _OffsetFst
                cmp     edx, 0
                jne     short @F
                ret
                
    @@:         sub     edx, 1
                cmp     byte ptr [esi + edx], '-'
                je      short @F
                ret
                
    @@:         mov     byte ptr [esi + edx], '+'
    
                cmp     dword ptr SignZ, 0        ; 0 = +     1 = -
                je      short @F
                ;
                mov     dword ptr SignZ, 0        ; 0 = +     1 = -                
                ret
                ;
    @@:         mov     dword ptr SignZ, 1        ; 0 = +     1 = -                
                ret
AdjustSign      endp
;
;   _TblOperandAt is an array of 2 dwords to save sign 
;                 and result of each operation  (each @)
;
; Output:
;       clc:    ResultZ = SignZ, OperandZ
;       
;       stc:    error/overflow 
;
;
LookExpress     proc    pRcl:DWORD
                push    esi
                
                mov     edx, offset _TblOperandAt
                mov     dword ptr [edx - 4], 0
                ;
    _start:     mov     esi, pRcl
                mov     ecx, dword ptr [esi - 4]                
                cmp     ecx, 0
                jne     short _loop1
                ;
    error1:     mov     ErrorZ, 0
    
    error2:     stc
                pop     esi
                ret
                
    _loop1:     sub     ecx, 1
                cmp     byte ptr [esi + ecx],')'
                je      short _found1
                ;
                cmp     ecx, 0
                jne     short _loop1
                ;
                ; not found
                ; 
                invoke  LookPower, esi
                jc      error2

                invoke  SolveExpress, esi
                pop     esi                
                ret            
;---
    _found1:    cmp     ecx, 0
                je      short error1
                ;
                mov     _OffsetLst, ecx
;---
    _loop2:     sub     ecx, 1
                movzx   eax, byte ptr [esi + ecx]
                cmp     al, '('
                je      short _found2
                
                cmp     al, ')'
                je      short _found1
                
                cmp     ecx, 0
                jne     short _loop2
                je      error1
;---
    _found2:    mov     _OffsetFst, ecx

                call    IsBaseExpo
                jnc     short _goon

                cmp     eax, 2
                je      _start
                jne     error2
;----------------------------------
    _goon:      mov     ebx, _OffsetLst
                sub     ebx, ecx
                sub     ebx, 1
                
                cmp     ebx, 0
                je      short _rem
                ;
                cmp     ebx, 1
                ja      short _found3
                ;
                ; Constant
                ;
                movzx   eax, byte ptr [esi + ecx + 1]

                cmp     al, '#'
                je      short _rem

                cmp     al, '@'
                je      short _rem
                
                cmp     al, '0'
                jb      error1
                
                cmp     al, '9'
                ja      error1
                ;
                ; Remove ()
                ; 
      _rem:     mov     ebx, _OffsetFst
                mov     byte ptr [esi + ebx], 20h
                mov     ebx, _OffsetLst
                mov     byte ptr [esi + ebx], 20h
                invoke  RemSpaces, esi
                jmp     _start
;---------------------------------------
    _found3:    mov     edi, offset WrkBuffer
                cmp     ebx, dword ptr [edi - 8]
                ja      error1
                ;
                push    esi
                
                add     esi, ecx        ; _OffsetFst
                add     esi, 1

                mov     dword ptr [edi - 4], ebx
                mov     byte ptr [edi + ebx], 0
                
        @@:     sub     ebx, 1                
                movzx   eax, byte ptr [esi + ebx]
                mov     byte ptr [edi + ebx], al
                jnz     short @B

                pop     esi

                ; 
                ;     Wrk is constant ?
                ; 
                invoke  VrfOperand, edi, [edi - 4]
                jnc     _rem                            ; yes
                
                cmp     eax, 1
                je      error1

                invoke  LookPower, addr WrkBuffer
                jc      error2
                ;
                ; Operation
                ; 
                invoke  SolveExpress, addr WrkBuffer
                jc      error2
                
                call    AdjustSign

                call    SaveAt

                ; 
                ;    Replace by AT
                ; 
                invoke  RemExpress, esi
                jmp     _start
LookExpress     endp
;
; From _OffsetFst="(" to _OffsetLst=")" we have brackets
;
; Output:
;           clc     - not power
;
;           stc:    EAX = 0 Error
;                   EAX = 1 Overflow
;                   EAX = 2 calculated
;
IsBaseExpo      proc
                push    ecx
                
                mov     ebx, _OffsetLst
                add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]
                jb      short @F
                ;
        no:     clc
        _exit:  pop     ecx
                ret
                ;
        @@:     cmp     byte ptr [esi + ebx], '^'
                jne     short no
                ;
                mov     eax, _OffsetFst
                mov     _OffsetBas1, eax
              
                call    GetPower
                jc      short _exit

                call    GetBaseExpo
                jc      short _exit
                
                call    CalcExpo
                jc      short _exit

                ; 
                ;     Replace by AT
                ; 
                mov     eax, _OffsetBas1
                mov     _OffsetFst, eax
                ;
                mov     eax, _OffsetBas2
                mov     _OffsetLst, eax
                
                invoke  RemExpress, esi

                call    SaveAt
                ;
                mov     eax, 2
                stc
                pop     ecx
                ret
IsBaseExpo      endp
;
;       ESI     - string
;
;
SignExpo        proc

                mov     ebx, _OffsetBas1
                cmp     ebx, 0
                jne     short @F
                
    _exit:      ret
                
    @@:         sub     ebx, 1                
                cmp     byte ptr [esi + ebx], '+'
                je      short _exit
                cmp     byte ptr [esi + ebx], '-'
                jne     short _exit                
                ;
                mov     byte ptr [esi + ebx], '+'
                
                cmp     SignZ, 0
                je      short @F
                ;
                mov     SignZ, 0
                ret                

    @@:         mov     SignZ, 1
                ret
SignExpo        endp
;
SignPower       proc

                xor     edx, edx
                mov     eax, ExponentZ
                mov     ecx, 2
                div     ecx
                cmp     edx, 0
                je      short @F
                ;
                clc
                ret
                
    @@:         mov     SignZ, 0
                clc
                ret
SignPower       endp
;
CalcExpo        proc

                mov     eax, OperandZ 
                cmp     eax, 0
                je      short _null
                ;               
                mov     ecx, ExponentZ
                
                cmp     ecx, 0
                je      short _one
                
                cmp     eax, 1
                je      short _sign     
                ;
                cmp     ecx, 1
                je      short next
                ;
                sub     ecx, 1
                mov     ebx, eax
                ;
      @@:       mul     ebx
                jc      short overflow
                ;
                ;mov     OperandZ, eax
                sub     ecx, 1
                jnz     short @B
                
                mov     OperandZ, eax                
                ;
    _sign:      call    SignPower
                jnc     short next      ; follow HERE
;---***---
    _one:       mov     OperandZ, 1
                mov     SignZ, 0
                ;
    next:       call    SignExpo
                clc
                ret

    _null:      mov     SignZ, 0
                clc
                ret
                
    overflow:   mov     ErrorZ, 1    
                mov     eax, 1
                stc
                ret                
CalcExpo        endp
;
; From _OffsetFst+1 to _OffsetLst-1 we have not brackets
;
GetBaseExpo     proc

                mov     ebx, _OffsetFst
                mov     edi, offset BaseBuffer
                xor     edx, edx
                jz      short _loop
                ;
    _next:      movzx   eax, byte ptr [esi + ebx]
                mov     byte ptr [edi + edx], al
                add     edx, 1
                ;
                cmp     edx, dword ptr [edi - 8]
                ja      short error
                ;                
    _loop:      add     ebx, 1
                cmp     ebx, _OffsetLst
                jb      short _next

                mov     dword ptr [edi - 4], edx
                
                cmp     edx, 0
                je      error

                invoke  LookPower, addr BaseBuffer
                jc      short error2
                                
                invoke  SolveExpress, addr BaseBuffer

                ret
;---***
    error:      mov     ErrorZ, 0    
                ;
    error2:     mov     eax, 0
                stc
                ret
GetBaseExpo     endp
;
GetPower        proc

                mov     edi, offset _Exponent
                xor     edx, edx
                ;
    _loop:      add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]
                jb      short _next
                ;
    _end:       cmp     edx, 0
                je      short error

                mov     dword ptr [edi - 4], edx                
                ;
                ; Convert
                ; -------
                invoke  CnvToDW, addr _Exponent
                jc      short overflow 

                mov     ExponentZ, eax
                cmp     eax, 31
                ja      short overflow
                ;                
                clc
                ret               
;---***---                
    _next:      movzx   eax, byte ptr [esi + ebx]
                cmp     al, '0'      
                jb      short _end
                cmp     al, '9'      
                ja      short _end
                ;
                mov     _OffsetBas2, ebx

                mov     byte ptr [edi + edx], al                
                add     edx, 1
                
                cmp     edx, LENOPERAND
                jbe     short _loop                
;---***
    error:      mov     ErrorZ, 0    
                mov     eax, 0
                stc
                ret
                
    overflow:   mov     ErrorZ, 1    
                mov     eax, 1
                stc
                ret
GetPower        endp
;
SaveAt          proc
                push    edi
                
                mov     edx, SignZ
                mov     eax, OperandZ

                mov     edi, offset _TblOperandAt
                mov     ebx, dword ptr [edi - 4]                

                push    ebx
                shl     ebx, 3
                mov     dword ptr [edi + ebx + 0], edx        ; SignZ
                mov     dword ptr [edi + ebx + 4], eax
                pop     ebx
                
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx

                pop     edi
                ret
SaveAt          endp
;
RetrieveAt      proc
                push    edi
                
                mov     edi, offset _TblOperandAt
                mov     ebx, dword ptr [edi - 4]
                cmp     ebx, 0
                je      short _erro
                ;
                sub     ebx, 1
                
                push    ebx
                ;
                shl     ebx, 3                
                mov     edx, dword ptr [edi + ebx + 0]        ; SignZ
                mov     eax, dword ptr [edi + ebx + 4]        ; OperandZ
                ;
                pop     ebx
                mov     dword ptr [edi - 4], ebx
                
                clc
                pop     edi
                ret                

    _erro:      ;mov     eax, 0
                ;mov     edx, 0
                stc
                pop     edi
                ret
RetrieveAt      endp
;
SaveEx          proc
                push    edi
                
                mov     edx, SignZ
                mov     eax, OperandZ

                mov     edi, offset _TblPower
                mov     ebx, dword ptr [edi - 4]

                push    ebx
                shl     ebx, 3
                mov     dword ptr [edi + ebx + 0], edx        ; SignZ
                mov     dword ptr [edi + ebx + 4], eax
                pop     ebx
                
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx

                pop     edi
                ret
SaveEx          endp
;
RetrieveEx      proc
                push    edi
                
                mov     edi, offset _TblPower
                mov     ebx, dword ptr [edi - 4]
                cmp     ebx, 0
                je      short _erro
                ;
                sub     ebx, 1
                
                push    ebx
                ;
                shl     ebx, 3                
                mov     edx, dword ptr [edi + ebx + 0]        ; SignZ
                mov     eax, dword ptr [edi + ebx + 4]        ; OperandZ
                ;
                pop     ebx
                mov     dword ptr [edi - 4], ebx
                
                clc
                pop     edi
                ret                

    _erro:      ;mov     eax, 0
                ;mov     edx, 0
                stc
                pop     edi
                ret
RetrieveEx      endp
;
; Output:
;           clc:    constant
;
;           stc:    EAX = 0   not constant
;                       = 1   erro
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
VrfOperand      proc    pRcl:DWORD, Len:DWORD
                push    esi
                push    edi

                mov     edi, offset _Operand
                mov     dword ptr [edi- 4], 0
                
                mov     esi, [esp + 12]            ; pRcl
                mov     ecx, [esp + 16]            ; Len
                cmp     ecx, 0
                jne     short @F
                
    erro:       mov     eax, 1
                stc
                pop     edi
                pop     esi
                ret     8
               
      @@:       xor     ebx, ebx
                ;
                movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                ;
                mov     _Sign, 1                
                cmp     al, '-'
                je      next1

                mov     _Sign, 0
                cmp     al, '+'
                je      next1
                ;
                cmp     al, '#'
                je      short _not                
                cmp     al, '@'
                je      short _not
                ;
                cmp     al, '0'
                jb      erro
                cmp     al, '9'
                ja      erro

Isdigit1:       cmp     ebx, LENOPERAND
                je      erro
                
                mov     byte ptr [edi + ebx], al
                add     ebx, 1
                mov     dword ptr [edi- 4], ebx                
;..................
next1:          cmp     ecx, 0
                jne     short @F
                ;
                ; Is constant
                ; 
                clc
                pop     edi                
                pop     esi                
                ret     8
;---                
        @@:     movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1

                cmp     al, '#'
                je      short IsEx

                cmp     al, '@'
                je      short IsAt

                cmp     al, '0'
                jb      short _not
                
                cmp     al, '9'
                jbe     short Isdigit1          ; is digit
                
    _not:       mov     eax, 0
                stc
                pop     edi                
                pop     esi                
                ret     8

     IsAt:      cmp     ebx, 0
                je      short _not
                jne     erro 
                
     IsEx:      cmp     ebx, 0
                je      short _not
                jne     erro 
VrfOperand      endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
;
;Output:
;       clc:    ResultZ
;       
;       stc:    error/overflow in ResultZ 
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
SolveExpress    proc    pRcl:DWORD
                push    esi
                ;
                mov     esi, [esp + 8]
                mov     ecx, dword ptr [esi - 4]

                ; If expression starts with 2 signs
                ; remove one
                call    SolveSign
                jc      error

                mov     edx, offset _TblOperand
                mov     dword ptr [edx - 4], 0

                mov     edx, offset _TblOperation
                mov     dword ptr [edx - 4], 0
                                
                invoke  GetOperandY, addr _Operand, addr _Sign, addr Operation
                jc      error

                cmp     _IsAt, 1
                je      IsAt1

                cmp     _IsEx, 1
                je      IsEx1
                
                cmp     ecx, 0
                je      _exit           ; Operation = 0
;---
                invoke  CnvToDW, addr _Operand
                jc      _overflow

                invoke  SetFstOperand, _Sign, eax
                call    SetOperation                
                jmp     _next

    IsAt1:      cmp     ecx, 0
                je      ExitAt
                
                call    SetOperation
                call    PutFstOperand    
                jc      error
                jmp     _next

    IsEx1:      cmp     ecx, 0
                je      ExitEx
                
                call    SetOperation
                call    ExpFstOperand    
                jc      error
   
;---
    _next:      invoke  GetOperandY, addr _Operand, addr _Sign, addr Operation
                jc      error
                ;
                cmp     _IsAt, 1
                je      short IsAt2
                cmp     _IsEx, 1
                je      short IsEx2
                
                cmp     ecx, 0
                je      _stop           ; Operation = 0
                                
                invoke  CnvToDW, addr _Operand
                jc      _overflow
                
                invoke  SetNxtOperand, _Sign, eax

                call    SetOperation
                jc      error
                
                jmp     short _next
;-----------------------------------
    IsAt2:      cmp     ecx, 0
                je      short @F        ; Operation = 0
                
                call    PutNxtOperand
                jc      error
                
                call    SetOperation
                jc      error
                jnc     short _next
                
        @@:     call    PutNxtOperand
                jc      error
                jmp     _solve

    IsEx2:      cmp     ecx, 0
                je      short @F        ; Operation = 0
                
                call    ExpNxtOperand
                jc      error
                
                call    SetOperation
                jc      error
                jnc     _next
                
        @@:     call    ExpNxtOperand
                jc      error
                jmp     _solve                
;-----------------------------------
    _stop:      invoke  CnvToDW, addr _Operand
                jc      _overflow
                
                invoke  SetNxtOperand, _Sign, eax

_solve:     
                call    SetLstOperand

                call    ResolveIt 
                
                pop     esi
                ret     4

    _exit:      invoke  CnvToDW, addr _Operand
                jc      short _overflow 

                mov     OperandZ, eax
                mov     eax, _Sign
                mov     SignZ, eax
                
                clc     
                pop     esi
                ret     4

     error:     mov     ErrorZ, 0     
                stc
                pop     esi
                ret     4

    _overflow:  mov     ErrorZ, 1
                stc
                pop     esi
                ret     4
                
    ExitAt:     call    RetrieveAt
                mov     OperandZ, eax
                mov     SignZ, edx

                pop     esi
                ret     4
                
    ExitEx:     call    RetrieveEx
                mov     OperandZ, eax
                mov     SignZ, edx

                pop     esi
                ret     4                
SolveExpress    endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef
;
SolveSign       proc
                cmp     ecx, 2
                ja      short @F
                ;
   _Ok:         clc
                ret
                ;
    @@:         movzx   eax, byte ptr [esi + 0]
                movzx   edx, byte ptr [esi + 1]
                cmp     al, '+'
                je      short _plus
                cmp     al, '-'
                jne     short _Ok
                ;
                ; AL = -
                ;
                cmp     dl, '+'
                je      short _minus
                cmp     dl, '-'
                jne     short _Ok

                mov     byte ptr [esi + 1], '+'
                je      short _rem
    
    _minus:     mov     byte ptr [esi + 1], '-'
                je      short _rem
;---***---
        
    _plus:      cmp     dl, '+'
                je      short _rem
                cmp     dl, '-'
                jne     short _Ok
                

    _rem:       cmp     byte ptr [esi + 2], '+'
                je      short error
                ;
                cmp     byte ptr [esi + 2], '-'
                je      short error

                mov     byte ptr [esi + 0], 20h
                add     esi, 1                                
                sub     ecx, 1
                clc
                ret
                ;
    error:      stc   
                ret
SolveSign       endp
;
SetOperation    proc
                push    edi
                
                mov     eax, Operation

                mov     edi, offset _TblOperation
                mov     ebx, dword ptr [edi - 4]
                mov     dword ptr [edi + ebx*4], eax
                add     ebx, 1
                
                cmp     ebx, dword ptr [edi - 8]
                ja      short @F                

                mov     dword ptr [edi - 4], ebx
                
                clc
                pop     edi
                ret
                ;
    @@:         stc                
                pop     edi
                ret                
SetOperation    endp
;
SetLstOperand   proc
                
                mov     edx, offset _TblOperation
                mov     eax, dword ptr [edx - 4]

                mov     edx, offset _TblOperand
                mov     dword ptr [edx - 4], eax
                                
                ret
SetLstOperand   endp
;
SetFstOperand   proc    Sign:DWORD, Opr:DWORD

                mov     eax, Opr
                mov     edx, Sign
                ;
                mov     ebx, offset _TblOperand
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax

                mov     dword ptr [ebx - 4], 1
                ;
                ret
SetFstOperand   endp
;
SetNxtOperand   proc    Sign:DWORD, Opr:DWORD
                push    edi
                ;
                mov     eax, Opr
                mov     edx, Sign
                
                mov     edi, offset _TblOperand
                mov     ebx, dword ptr [edi - 4]
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax                 
;---
                mov     ebx, dword ptr [edi - 4]
                sub     ebx, 1
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN2$], edx
                mov     dword ptr [ebx + $OPR2$], eax
;---
                mov     ebx, dword ptr [edi - 4]
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx

                pop     edi
                ret
SetNxtOperand   endp
;
PutFstOperand   proc

                call    RetrieveAt
                ;
                mov     ebx, offset _TblOperand
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax

                mov     dword ptr [ebx - 4], 1
                ;
                ret
PutFstOperand   endp
;
PutNxtOperand   proc
                push    edi
                ;
                call    RetrieveAt
                jc      _erro
                
                mov     edi, offset _TblOperand
                mov     ebx, dword ptr [edi - 4]
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax                 
;---
                mov     ebx, dword ptr [edi - 4]
                sub     ebx, 1
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN2$], edx
                mov     dword ptr [ebx + $OPR2$], eax
;---
                mov     ebx, dword ptr [edi - 4]
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx
                clc
                
    _erro:      pop     edi
                ret
PutNxtOperand   endp
;
ExpFstOperand   proc

                call    RetrieveEx
                ;
                mov     ebx, offset _TblOperand
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax

                mov     dword ptr [ebx - 4], 1
                ;
                ret
ExpFstOperand   endp
;
ExpNxtOperand   proc
                push    edi
                ;
                call    RetrieveEx
                jc      _erro
                
                mov     edi, offset _TblOperand
                mov     ebx, dword ptr [edi - 4]
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN1$], edx
                mov     dword ptr [ebx + $OPR1$], eax                 
;---
                mov     ebx, dword ptr [edi - 4]
                sub     ebx, 1
                shl     ebx, 4
                add     ebx, edi
                ;
                mov     dword ptr [ebx + $SIGN2$], edx
                mov     dword ptr [ebx + $OPR2$], eax
;---
                mov     ebx, dword ptr [edi - 4]
                add     ebx, 1
                mov     dword ptr [edi - 4], ebx
                clc
                
    _erro:      pop     edi
                ret
ExpNxtOperand   endp
; 
; Input:
;           ESI     - pBufer
;           ECX     - buffer length
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE     
GetOperandY     proc    pOpr:DWORD, oSign:DWORD, pOper:DWORD

                mov     _IsAt, 0
                mov     _IsEx, 0

                cmp     ecx, 0
                jne     short @F
                
   _erro:       stc
                ret     12
;................. Operand 1 ............... 
               
@@:             mov     edi, [esp + 4]              ; pOpr      Operand
                mov     edx, [esp + 8]              ; oSign     Sign
                mov     ebx, [esp + 12]             ; pOper     Operation

                mov     dword ptr [ebx], 0
                mov     dword ptr [edi - 4], 0
                ;
                xor     ebx, ebx
                
                movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                ;
                mov     dword ptr [edx], 1
                cmp     al, '-'
                je      _next1

                mov     dword ptr [edx], 0               
                cmp     al, '+'
                je      _next1
                ;
                cmp     al, '@'
                je      IsAt1     

                cmp     al, '#'
                je      IsEx1                
        
                cmp     al, '0'
                jb      _erro
                cmp     al, '9'
                ja      _erro

   _Isdigit1:   cmp     ebx, LENOPERAND
                je      _erro
                ;
                mov     byte ptr [edi + ebx], al
                add     ebx, 1                
                mov     dword ptr [edi - 4], ebx                                
;..................
   _next1:      cmp     ecx, 0
                je      _exit

                movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1

                cmp     al, '@'
                je      IsAt2 

                cmp     al, '#'
                je      IsEx2
    
                cmp     al, '0'
                jb      short @F
                
                cmp     al, '9'
                jbe     short _Isdigit1            ; is digit
                
;................. Operation ...............

    @@:         mov     edx, [esp + 12]             ; pOper
                call    IsOperation
                jne     _erro
                
;................. Operand 2 ...............
                cmp     ecx, 0
                je      _erro
                ; 
                ; Termina com operao 
                ; Falta prximo operando
                ; 
                clc             
                ret     12
                ; 
                ; Termina com operando 
                ;       ECX = 0
                ; 
   _exit:       cmp     ebx, 0
                je      _erro
   
    _sai:       clc
                ret     12
;---***---
    IsAt1:      mov     _IsAt, 1
    
    ExitAt:     cmp     ecx, 0
                je      short _sai
                ;                       
                ;................. Operation ...............
                movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                                
                mov     edx, [esp + 12]             ; pOper
                call    IsOperation
                jne     _erro

                cmp     ecx, 0
                je      _erro
                
                clc
                ret     12
                
;---***---      sign + AT

    IsAt2:      mov     _IsAt, 1
                cmp     ebx, 0
                je      short ExitAt
                jne     _erro

;------------------------------------------
    IsEx1:      mov     _IsEx, 1
    
    ExitEx:     cmp     ecx, 0
                je      short _sai
                ;                       
                ;............... Operation ...............
                movzx   eax, byte ptr [esi]
                add     esi, 1
                sub     ecx, 1
                                
                mov     edx, [esp + 12]             ; pOper
                call    IsOperation
                jne     _erro

                cmp     ecx, 0
                je      _erro
                
                clc
                ret     12
                
;---***---      sign + #

    IsEx2:      mov     _IsEx, 1
                cmp     ebx, 0
                je      short ExitEx
                jne     _erro
GetOperandY     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
;
IsOperation     proc

                mov     dword ptr [edx], 1          ; Sub
                cmp     al, '-'
                je      short @F
                mov     dword ptr [edx], 2          ; Add
                cmp     al, '+'
                je      short @F
                mov     dword ptr [edx], 3          ; Mul
                cmp     al, '*'
                je      short @F
                mov     dword ptr [edx], 4          ; Div
                cmp     al, '/'
                je      short @F
                mov     dword ptr [edx], 5          ; Rem
                cmp     al, '\'
                je      short @F

    @@:         ret
IsOperation     endp
;
; Output:
;           clc:    correct: sign  in SignZ
;                            value in OperandZ
;           
;           stc:    error/overflow in ResultZ 
;
ResolveIt       proc

                mov     esi, offset _TblOperation
                xor     ebx, ebx

    _loop1:     mov     edi, offset _TblOperand
                mov     edx, dword ptr [esi + ebx*4]
                cmp     edx, 3
                jb      short _next1
                ;
                push    ebx
                    shl     ebx, 4
                    invoke  OperationAB,[edi + ebx + $SIGN1$], [edi + ebx + $OPR1$], 
                                        [edi + ebx + $SIGN2$], [edi + ebx + $OPR2$], edx
                pop     ebx
                jc      _end

                mov     dword ptr [esi + ebx*4], 0

                call    SaveAntRes
                call    SaveNxtRes
                jnc     short _next1
                ;
                cmp     _NoAnt, 0
                je      _Ok                 ; FIM
                ;
    _next1:     add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]
                jb      short _loop1
    ;---***---
                xor     ebx, ebx

    _loop2:     mov     edi, offset _TblOperand
                mov     edx, dword ptr [esi + ebx*4]
                cmp     edx, 0
                je      short _next2
                ;
                push    ebx
                    shl     ebx, 4
                    invoke  OperationAB,[edi + ebx + $SIGN1$], [edi + ebx + $OPR1$], 
                                        [edi + ebx + $SIGN2$], [edi + ebx + $OPR2$], edx
                pop     ebx
                jc      _end
                
                call    SaveNxtRes
                jnc     short _next2
                ;
                ; END
                ; 
    _Ok:        clc
                ret
                ;
    _next2:     add     ebx, 1
                cmp     ebx, dword ptr [esi - 4]
                jb      short _loop2
                ; 
                ; It cannot end HERE
                ; 
                mov     ErrorZ, 2
                stc    
    _end:       ret
ResolveIt       endp
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
OperationAB     proc    Sin1:DWORD, Opr1:DWORD, Sin2:DWORD, Opr2:DWORD, Opr:DWORD
                push    ebx
                
                mov     eax, [esp + 8]          ;Sin1
                mov     dl, al
                mov     eax, [esp + 16]         ;Sin2
                mov     dh, al
                
                movzx   eax, dl                
                mov     dword ptr SignZ, eax        ; 0 = +     1 = -

                mov     ebx, [esp + 12]         ;Opr1
                mov     ecx, [esp + 20]         ;Opr2

                mov     eax, [esp + 24]         ;Opr

                    cmp     eax, 3
                    jae     _case3

                    cmp     eax, 2
                    je      short _case2

                        mov     al, 1
                                                
                        cmp     dh, 0
                        je      short @F

                        mov     al, 0
                        
                @@:     mov     dh, al
                
          _case2:       cmp     dl, dh                      ; Add
                        je      short _add
                        
                        cmp     ebx, ecx
                        jae     short _sub
                        ;
                        movzx   eax, dh
                        mov     dword ptr SignZ, eax        ; 0 = +     1 = -
                        xchg    ebx, ecx
                        
           _sub:        sub     ebx, ecx
                        jmp     _exit
                        
           _add:        add     ebx, ecx
                        jc      erro1                        
                        jnc     _exit
                        
          _case3:       mov     dword ptr SignZ, 0 ; 0 = +     1 = -

                        cmp     dl, dh
                        je      short @F

                        mov     dword ptr SignZ, 1 ; 0 = +     1 = -

              @@:   cmp     eax, 3                  ; Mul
                    jne     _case4          

                        mov     eax, ebx
                        mul     ecx
                        jc      erro1
                        
                        mov     ebx, eax

                    jmp     _exit                        
          _case4:   cmp     eax, 4                  ; Div
                    jne     _case5
                    
                        cmp     ecx, 0
                        je      erro2

                        xor     edx, edx
                        mov     eax, ebx
                        div     ecx
                        mov     ebx, eax

                    jmp     _exit                                                
          _case5:   cmp     eax, 5                  ; Remainder
                    jne     erro2

                        cmp     ecx, 0
                        je      erro2

                        xor     edx, edx                        
                        mov     eax, ebx
                        div     ecx
                        mov     ebx, edx

_exit:          mov     OperandZ, ebx
                clc
                pop     ebx
                ret     20
                
erro1:          mov     ErrorZ, 1
                stc
                pop     ebx
                ret     20
                
erro2:          mov     ErrorZ, 0
                stc
                pop     ebx
                ret     20
OperationAB     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
;
SaveAntRes      proc
                push    ebx

                mov     _NoAnt, 0
                ;
    _next:      cmp     ebx, 0
                je      short _no
                ;
                sub     ebx, 1
                cmp     dword ptr [esi + ebx*4], 0
                je      short _next
                ;
                shl     ebx, 4
                add     ebx, offset _TblOperand

                mov     eax, SignZ
                mov     edx, OperandZ
                mov     dword ptr [ebx + $SIGN2$], eax
                mov     dword ptr [ebx + $OPR2$], edx

                mov     _NoAnt, 1
 
                clc
                pop     ebx
                ret
                ;
    _no:        stc
                pop     ebx
                ret
SaveAntRes      endp
;
SaveNxtRes      proc
                push    ebx
                ;
                mov     edx, dword ptr [esi - 4]
                sub     edx, 1
                
    _next:      cmp     ebx, edx
                jae     short _no
                ;
                add     ebx, 1
                cmp     dword ptr [esi + ebx*4], 0
                je      short _next
                ;
                shl     ebx, 4
                add     ebx, offset _TblOperand

                mov     eax, SignZ
                mov     edx, OperandZ
                mov     dword ptr [ebx + $SIGN1$], eax
                mov     dword ptr [ebx + $OPR1$], edx
 
                clc
                pop     ebx
                ret
                ;
    _no:        stc
                pop     ebx
                ret
SaveNxtRes      endp
;
                    ;include     Debug.asm
                    include     Calcula19.inc
;........................................................
end   start   
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
